<template>
  <div>
    <div class="map-wrapper" :style="mapWrapperStyle">
      <button
        v-if="!draggableMap"
        @click.stop="launchMapModal('button')"
        class="map-btn map-btn--fullscreen pointer"
        aria-label="zoom"
      ></button>
      <div v-if="draggableMap" ref="draggableMap" class="draggable-map">
        <img
          @load="draggableImageLoad"
          @mousedown="startDraggingMap"
          class="draggable-map__image"
          :class="{ dragging: isDraggingMap }"
          ref="draggableMapImage"
          :src="draggableMapImageSrc"
          :style="draggableMapImageStyle"
        />
      </div>
      <div
        v-if="!draggableMap"
        @click="launchMapModal('background')"
        class="map"
        :style="infoMapStyle"
      >
        <div
          v-inview:class="['show']"
          class="pin"
          :style="buildingPosition[isMobile ? 'small' : 'large']"
        >
          <div
            class="pin__logo"
            :style="{ 'background-color': company.webBannerBackgroundColor }"
          >
            <div
              class="pin__logo-img overflow-hidden abs-full bg-center-contain-nr"
              :style="{ 'background-image': `url('${logo}')` }"
            ></div>
          </div>
          <div class="pin__location">
            {{ buildingName }} {{ floor | floorName }}
          </div>
        </div>
      </div>
    </div>

    <modal
      v-if="showMapModal"
      ref="mapModal"
      @close="showMapModal = false"
      :style="bigMapScrollable ? {} : { overflow: 'hidden' }"
    >
      <div>
        <button
          class="map-btn map-btn--locate pointer"
          @click="locate"
          aria-label="locate"
        ></button>
        <div class="spin-bg"></div>
        <div
          @mousedown="startDragging"
          ref="bigMap"
          class="big-map"
          :class="{ dragging: isDragging }"
          :style="bigMapStyle"
        >
          <div
            v-if="showPin"
            ref="bigMapPin"
            class="pin show"
            :style="
              buildingPosition[isMobile ? 'smallExpanded' : 'expanded'] ||
                buildingPosition.large
            "
          >
            <div
              class="pin__logo"
              :style="{ 'background-color': company.webBannerBackgroundColor }"
            >
              <div
                class="pin__logo-img overflow-hidden abs-full bg-center-contain-nr"
                :style="{ 'background-image': `url('${logo}')` }"
              ></div>
            </div>
            <div class="pin__location">
              {{ buildingName }} {{ floor | floorName }}
            </div>
          </div>
        </div>
      </div>
    </modal>

    <dl class="info-list reset-list">
      <dt>{{ $t("restaurant.location") }}</dt>
      <dd>{{ buildingAddress }}</dd>
      <dt>{{ $t("restaurant.type") }}</dt>
      <dd>{{ $t(`restaurantTypes.${restaurant.restaurantType}`) }}</dd>
      <template v-if="restaurant.minimumCharge">
        <dt>{{ $t("restaurant.minimumCharge") }}</dt>
        <dd
          v-html="
            restaurant.minimumCharge.replace(/(?:\r\n|\r|\\n)/g, '<br />')
          "
        ></dd>
      </template>
      <dt>{{ $t("restaurant.phone") }}</dt>
      <dd>
        <a :href="`tel:${restaurant.phoneNumber}`">{{
          restaurant.phoneNumber
        }}</a>
      </dd>
      <dt>{{ $t("restaurant.openingTime") }}</dt>
      <dd>
        <ul class="reset-list">
          <li v-for="t in restaurant.openingTimes">{{ t.from }}-{{ t.to }}</li>
        </ul>
      </dd>
      <dt>{{ $t("restaurant.acceptablePaymentOption") }}</dt>
      <dd>{{ $t("restaurant.acceptablePaymentOptions") }}</dd>
    </dl>
  </div>
</template>
<script>
import { mapState } from "vuex";
import ease from "ease-component";
import Modal from "@/components/Modal";
import getBigMap from "@/const/bigmap.js";

const buildingPositionMappings = {
  "skm-xinyi": {
    124: {
      small: { left: "47%", top: "32%" },
      large: { left: "72%", top: "29%" }
    },
    122: {
      small: { left: "60%", top: "32%" },
      large: { left: "55.5%", top: "37%" }
    },
    123: {
      small: { left: "50%", top: "32%" },
      large: { left: "32%", top: "46%" }
    },
    121: {
      small: { left: "44%", top: "36%" },
      large: { left: "39%", top: "57%" }
    }
  },
  "skm-taichung": {
    main: {
      small: { left: "50%", top: "30%" },
      large: { left: "52%", top: "40%" },
      expanded: { left: "50%", top: "35%" },
      smallExpanded: { left: "50%", top: "40%" }
    }
  },
  "skm-nanxi": {
    101: {
      small: { left: "50%", top: "35%" },
      large: { left: "50%", top: "35%" },
      expanded: { left: "50%", top: "25%" },
      smallExpanded: { left: "50%", top: "33%" }
    },
    102: {
      small: { left: "45%", top: "40%" },
      large: { left: "45%", top: "42%" },
      expanded: { left: "58%", top: "45%" },
      smallExpanded: { left: "58%", top: "45%" }
    },
    103: {
      small: { left: "55%", top: "27%" },
      large: { left: "55%", top: "30%" },
      expanded: { left: "36%", top: "21%" },
      smallExpanded: { left: "36%", top: "32%" }
    }
  },
  "skm-tainanplace": {
    321: {
      small: { left: "36%", top: "56%" },
      large: { left: "36%", top: "56%" },
      expanded: { left: "44%", top: "52%" },
      smallExpanded: { left: "40%", top: "52%" }
    },
    322: {
      small: { left: "30%", top: "36%" },
      large: { left: "30%", top: "36%" },
      expanded: { left: "40%", top: "33%" },
      smallExpanded: { left: "34%", top: "33%" }
    }
  },
  "skm-TaipeiTianmu": {
    151: {
      small: { left: "50%", top: "36%" },
      large: { left: "55%", top: "40%" },
      expanded: { left: "60%", top: "36%" },
      smallExpanded: { left: "57%", top: "39%" }
    },
    152: {
      small: { left: "50%", top: "40%" },
      large: { left: "38%", top: "40%" },
      expanded: { left: "40%", top: "40%" },
      smallExpanded: { left: "40%", top: "45%" }
    }
  },
  "skm-TaipeiStation": {
    111: {
      small: { left: "49%", top: "30%" },
      large: { left: "48%", top: "30%" },
      expanded: { left: "50%", top: "60%" },
      smallExpanded: { left: "50%", top: "60%" }
    }
  },
  "skm-KaohsiungSanduo": {
    301: {
      small: { left: "49%", top: "35%" },
      large: { left: "48%", top: "35%" },
      expanded: { left: "50%", top: "35%" },
      smallExpanded: { left: "50%", top: "37%" }
    }
  },
  "skm-TainanZhongshan": {
    311: {
      small: { left: "45%", top: "28%" },
      large: { left: "45%", top: "37%" },
      expanded: { left: "38%", top: "30%" },
      smallExpanded: { left: "36%", top: "32%" }
    }
  },
  "skm-KaohsiungZuoying": {
    351: {
      small: { left: "40%", top: "35%" },
      large: { left: "50%", top: "35%" },
      expanded: { left: "65%", top: "25%" },
      smallExpanded: { left: "65%", top: "33%" }
    },
    352: {
      small: { left: "50%", top: "50%" },
      large: { left: "52%", top: "49%" },
      expanded: { left: "42%", top: "55%" },
      smallExpanded: { left: "40%", top: "57%" }
    }
  },
  "skm-ChiayiChuiyang": {
    331: {
      small: { left: "50%", top: "35%" },
      large: { left: "50%", top: "35%" },
      expanded: { left: "50%", top: "35%" },
      smallExpanded: { left: "50%", top: "40%" }
    }
  },
  "skm-TaoyuanDayou": {
    161: {
      small: { left: "50%", top: "35%" },
      large: { left: "50%", top: "35%" },
      expanded: { left: "50%", top: "35%" },
      smallExpanded: { left: "50%", top: "40%" }
    }
  },
  "skm-TaoyuanStation": {
    171: {
      small: { left: "50%", top: "35%" },
      large: { left: "50%", top: "35%" },
      expanded: { left: "50%", top: "35%" },
      smallExpanded: { left: "50%", top: "40%" }
    }
  }
};

const oneBuildingGroup = {
  taichung: true,
  TaipeiStation: true,
  KaohsiungSanduo: true,
  TainanZhongshan: true,
  ChiayiChuiyang: true,
  TaoyuanDayou: true,
  TaoyuanStation: true
};

const bigMapSettings = {
  "skm-xinyi": {
    style: {
      width: "200%"
    },
    showPin: true,
    scrollable: true,
    highestFloor: 9,
    totalFloor: 11
  },
  "skm-taichung": {
    style: {
      width: "200%",
      "background-size": "contain"
    },
    showPin: true,
    scrollable: true,
    highestFloor: 9,
    totalFloor: 12
  },
  "skm-nanxi": {
    style: {
      width: "200%"
    },
    showPin: true,
    scrollable: true,
    highestFloor: 9,
    totalFloor: 11
  },
  "skm-tainanplace": {
    style: {
      width: "200%"
    },
    showPin: true,
    scrollable: true,
    highestFloor: 10,
    totalFloor: 13
  },
  "skm-TaipeiTianmu": {
    style: {
      width: "200%"
    },
    showPin: true,
    scrollable: true,
    highestFloor: 10,
    totalFloor: 13
  },
  "skm-TaipeiStation": {
    style: {
      width: "200%"
    },
    showPin: true,
    scrollable: true,
    highestFloor: 10,
    totalFloor: 13
  },
  "skm-KaohsiungSanduo": {
    style: {
      width: "200%"
    },
    showPin: true,
    scrollable: true
  },
  "skm-TainanZhongshan": {
    style: {
      width: "200%"
    },
    showPin: true,
    scrollable: true
  },
  "skm-KaohsiungZuoying": {
    style: {
      width: "200%"
    },
    showPin: true,
    scrollable: true
  },
  "skm-ChiayiChuiyang": {
    style: {
      width: "200%"
    },
    showPin: true,
    scrollable: true
  },
  "skm-TaoyuanDayou": {
    style: {
      width: "200%"
    },
    showPin: true,
    scrollable: true
  },
  "skm-TaoyuanStation": {
    style: {
      width: "200%"
    },
    showPin: true,
    scrollable: true
  }
};

export default {
  components: {
    Modal
  },
  props: {
    restaurant: {
      type: Object,
      required: true
    },

    // NOTE: should be this.restaurant.groupId
    groupId: {
      type: String,
      required: true
    }
  },
  data() {
    return {
      showMapModal: false,
      isDragging: false,
      isMounted: false,
      draggableImageLoaded: false,
      isDraggingMap: false,
      draggableMapOffset: {
        left: 0,
        top: 0
      }
    };
  },
  computed: {
    ...mapState(["isMobile"]),
    infoMapStyle() {
      return {
        "background-image": `url(${
          this.isMobile ? this.mapImage : this.desktopImage
        })`,
        "background-size":
          this.isMobile && this.realGroupId === "TainanZhongshan"
            ? "180%"
            : "100%"
      };
    },
    draggableMap() {
      return false;
    },
    showPin() {
      return bigMapSettings[this.groupId].showPin;
    },
    company() {
      return this.restaurant.company;
    },
    logo() {
      return this.restaurant.logo;
    },
    building() {
      // NOTE: ad-hoc hardcode
      if (this.realGroupId === "taichung") {
        return "main";
      }
      return this.restaurant.buildingId;
    },
    buildingAddress() {
      // NOTE: ad-hoc hardcode
      if (oneBuildingGroup[this.realGroupId]) {
        return this.restaurant.buildingAddressWithoutBuilding;
      }
      return this.restaurant.buildingAddress;
    },
    buildingName() {
      // NOTE: ad-hoc hardcode
      if (oneBuildingGroup[this.realGroupId]) {
        return "";
      }
      return this.restaurant.buildingName;
    },
    floor() {
      return this.restaurant.floor;
    },
    mapWrapperStyle() {
      return {
        cursor: "pointer"
      };
    },
    // NOTE: skm-{realGroupId}
    realGroupId() {
      return this.groupId.split("-")[1];
    },
    // NOTE: mobile map
    mapImage() {
      return `/static/images/building/${this.realGroupId}/${this.building}.jpg`;
    },
    // NOTE: desktop map
    desktopImage() {
      switch (this.groupId) {
        case "skm-xinyi":
          return this.bigMapImage;
        case "skm-taichung":
        case "skm-nanxi":
        case "skm-tainanplace":
        case "skm-TaipeiTianmu":
        case "skm-TaipeiStation":
        case "skm-KaohsiungSanduo":
        case "skm-TainanZhongshan":
        case "skm-KaohsiungZuoying":
        case "skm-ChiayiChuiyang":
        case "skm-TaoyuanDayou":
        case "skm-TaoyuanStation":
          return this.mapImage;
        default:
          throw new Error("invalid group id");
      }
    },
    // NOTE: full-screen map
    bigMapImage() {
      return getBigMap(
        this.groupId,
        this.restaurant.buildingId,
        this.restaurant.id
      );
    },
    bigMapStyle() {
      const style = Object.assign(
        {
          "background-image": `url(${this.bigMapImage})`
        },
        bigMapSettings[this.groupId].style
      );
      return style;
    },
    bigMapScrollable() {
      return bigMapSettings[this.groupId].scrollable;
    },
    buildingPosition() {
      return buildingPositionMappings[this.groupId][this.building] || {};
    },
    // draggable map
    draggableMapImageSrc() {
      return (
        this.bigMapImage || (this.isMobile ? this.mapImage : this.desktopImage)
      );
    },
    draggableMapImageStyle() {
      if (!this.draggableImageLoaded) {
        return;
      }
      const rect = this.$refs.draggableMap.getBoundingClientRect();
      const el = this.$refs.draggableMapImage;
      const maxTopOffset = Math.abs(el.height - rect.height) / 2;
      const topOffset =
        (bigMapSettings[this.groupId].highestFloor - this.floor) *
        (maxTopOffset / bigMapSettings[this.groupId].totalFloor) *
        -1;
      const center = {
        left: (rect.width - el.width) / 2,
        top: (rect.height - el.height) / 2
      };
      var top = this.draggableMapOffset.top + topOffset;
      var left = this.draggableMapOffset.left;
      return {
        left: `${center.left + left}px`,
        top: `${center.top + top}px`
      };
    }
  },
  watch: {
    showMapModal(v) {
      if (v) {
        setTimeout(() => {
          this.locate();
        });
      }
    }
  },
  methods: {
    locate() {
      if (!this.showPin) {
        let mapModal = this.$refs.mapModal;
        let modalRect = mapModal.$el.getBoundingClientRect();
        let bigMap = this.$refs.bigMap;
        let bigMapRect = bigMap.getBoundingClientRect();
        mapModal.$el.scrollTop = (bigMapRect.height - modalRect.height) / 2;
        mapModal.$el.scrollLeft = (bigMapRect.width - modalRect.width) / 2;
      } else {
        const { mapModal, bigMapPin } = this.$refs;
        const { left, top } = bigMapPin.getBoundingClientRect();
        const { width, height } = mapModal.$el.getBoundingClientRect();
        mapModal.$el.scrollTop = mapModal.$el.scrollTop + top - height / 2;
        mapModal.$el.scrollLeft = mapModal.$el.scrollLeft + left - width / 2;
      }
    },
    startDragging(e) {
      if (!this.bigMapScrollable) {
        return;
      }
      const { mapModal } = this.$refs;
      this.isDragging = true;
      this.draggingOrigin = { x: e.clientX, y: e.clientY };
      this.mapOrigin = {
        x: mapModal.$el.scrollLeft,
        y: mapModal.$el.scrollTop
      };
      window.addEventListener("mousemove", this.dragging);
      window.addEventListener("mouseup", this.endDragging);
    },
    dragging(e) {
      const { mapModal } = this.$refs;
      mapModal.$el.scrollLeft =
        this.mapOrigin.x + (this.draggingOrigin.x - e.clientX);
      mapModal.$el.scrollTop =
        this.mapOrigin.y + (this.draggingOrigin.y - e.clientY);
    },
    endDragging(e) {
      this.isDragging = false;
      window.removeEventListener("mousemove", this.dragging);
      window.removeEventListener("mouseup", this.endDragging);
    },
    launchMapModal(by) {
      this.showMapModal = true;
      window.gtag("event", "Street map - Open", {
        event_label: JSON.stringify({
          by,
          ...this.restaurant.dataForMixpanel
        })
      });
    },
    // draggable map
    draggableImageLoad() {
      this.draggableImageLoaded = true;
    },
    startDraggingMap(e) {
      if (this.isDraggingMap || this.isMobile) {
        return;
      }
      e.preventDefault();
      this.isDraggingMap = true;
      this.draggingMapOrigin = { x: e.clientX, y: e.clientY };
      window.addEventListener("mousemove", this.draggingMap);
      window.addEventListener("mouseup", this.endDraggingMap);
    },
    draggingMap(e) {
      const rect = this.$refs.draggableMap.getBoundingClientRect();
      this.draggableMapOffset = {
        left:
          (e.clientX - this.draggingMapOrigin.x) *
          0.7 *
          ease.outQuad(
            Math.abs(e.clientX - this.draggingMapOrigin.x) / rect.width
          ),
        top:
          (e.clientY - this.draggingMapOrigin.y) *
          0.7 *
          ease.outQuad(
            Math.abs(e.clientY - this.draggingMapOrigin.y) / rect.height
          )
      };
    },
    endDraggingMap(e) {
      this.isDraggingMap = false;
      this.draggableMapOffset = {
        left: 0,
        top: 0
      };
      window.removeEventListener("mousemove", this.draggingMap);
      window.removeEventListener("mouseup", this.endDraggingMap);
    }
  },
  mounted() {
    this.isMounted = true;
  }
};
</script>
<style scoped lang="scss">
.big-map {
  position: relative;
  padding-bottom: 228.18035426%;
  width: 200%;
  background-position: center;
  background-repeat: no-repeat;
  background-size: cover;
  cursor: -webkit-grab;

  &.dragging {
    cursor: -webkit-grabbing;
  }
  @include media-breakpoint-up(md) {
    width: 125%;
    padding-bottom: 142.6127214125%;
  }
}

.map-btn {
  z-index: 1;
  width: 40px;
  height: 40px;
  border: none;
  border-radius: 3px;
  box-shadow: 0 2px 3px 2px rgba($color-secondary-black, 0.3);

  &--locate {
    position: fixed;
    right: 10px;
    bottom: 10px;
    background: $color-white url("/static/images/ic-locate.svg") center/contain
      no-repeat;

    @include media-breakpoint-up(md) {
      transform: scale(1.5);
      right: 50px;
      bottom: 50px;
    }
  }

  &--fullscreen {
    position: absolute;
    right: 20px;
    bottom: 20px;
    background: $color-white url("/static/images/ic-fullscreen.svg")
      center/contain no-repeat;
    transition: all 0.3s;

    &:hover,
    &:active {
      transform: scale(0.9);
    }
  }
}

.map-wrapper {
  overflow: hidden;
  position: relative;

  &:after {
    content: "";
    display: block;
    position: absolute;
    left: 0;
    bottom: 0;
    width: 100%;
    padding-bottom: 18.66666667%;
    background-image: linear-gradient(
      to bottom,
      rgba(0, 0, 0, 0),
      rgba(0, 0, 0, 0.3)
    );
  }

  @include media-breakpoint-up(md) {
    padding-bottom: 75%;

    &:after {
      content: none;
    }
  }
}

.map {
  position: relative;
  background-color: $color-silver-grey;
  left: 0;
  width: 100%;
  padding-bottom: 133.33%;
  background-position: center;
  background-repeat: no-repeat;
  background-size: cover;
  @include media-breakpoint-up(md) {
    position: absolute;
    top: 50%;
    transform: translateY(-50%);
  }
}

.pin {
  position: absolute;
  transition: all 0.3s;
  transform: translateY(-50px);
  opacity: 0;
  width: 1px;
  height: 1px;

  &.show {
    transform: none;
    opacity: 1;
    transition: all 0.3s 0.3s;
  }

  @include media-breakpoint-up(md) {
    transform: translateY(-100px) scale(1.5);

    &.show {
      transform: scale(1.5);
      opacity: 1;
      transition: all 0.3s 0.3s;
    }
  }
}

.pin__logo {
  position: absolute;
  bottom: 0;
  transform: translateX(-50%) translateY(-8px);
  z-index: 1;
  background-color: $color-white;
  width: 42px;
  height: 42px;
  padding: 3px;
  border: 2px solid $color-white;
  border-radius: 50%;

  &:after {
    content: "";
    position: absolute;
    bottom: -8px;
    left: 50%;
    transform: translateX(-50%);
    border-width: 8px 5px 0 5px;
    border-color: $color-white transparent transparent transparent;
    border-style: solid;
  }
}

.pin__logo-img {
  border-radius: 50%;
}

.pin__location {
  position: absolute;
  left: -5px;
  top: -45px;
  background-color: $color-white;
  line-height: 34px;
  height: 34px;
  border-radius: 0 17px 17px 0;
  bottom: 0;
  padding: 0 13px 0 32px;
  white-space: nowrap;
}

.info-list {
  padding: 0 0 0$grid-gutter-width * 1.5;

  dt {
    font-weight: 500;
    color: $color-primary-black;
    padding-top: $grid-gutter-width/2;
    margin-bottom: $grid-gutter-width/4;
  }

  dd + dt {
    border-top: 1px solid $color-silver-grey;
    margin-top: $grid-gutter-width/2;
  }

  dd {
    padding-right: $grid-gutter-width * 1.5;
    color: $color-secondary-black;
  }

  dd:last-child {
    padding-bottom: $grid-gutter-width;
  }
}

.spin-bg {
  position: fixed;
  left: 0;
  top: 0;
  width: 100%;
  height: 100%;
  background-color: rgba(0, 0, 0, 0.9);

  &:before {
    content: "";
    @include spin;
  }

  .fade-leave-to & {
    display: none;
  }
}

.draggable-map {
  position: relative;
  background-color: $color-silver-grey;
  left: 0;
  width: 100%;
  padding-bottom: 133.33%;
  overflow: hidden;

  @include media-breakpoint-up(md) {
    position: absolute;
    left: 0;
    top: 0;
    width: 100%;
    height: 100%;
    padding: 0;
  }
}

.draggable-map__image {
  cursor: -webkit-grab;
  position: absolute;
  width: 100%;
  height: auto;
  transition: all 0.2s;

  &.dragging {
    transition: none;
    cursor: -webkit-grabbing;
  }
}
</style>
